#!/bin/bash

PWD=`pwd`
IMG_DIR=$PWD/image
ZIMAGE_PATH=$IMG_DIR/zImage
CRAMFS_TARGET=$IMG_DIR/target.cramfs
KR_SIZE=`ls -l $ZIMAGE_PATH|awk '{print $5}'`
FS_SIZE=`ls -l $CRAMFS_TARGET|awk '{print $5}'`

ErrorOut()
{
	echo $1
	exit 1
}

if [ ! -f "$ZIMAGE_PATH" ]; then
	ErrorOut "Kernel image not found."
fi

if [ ! -f "$CRAMFS_TARGET" ]; then
	ErrorOut "File system image not found."
fi

$PWD/apps/header/header $KR_SIZE $FS_SIZE $1 $IMG_DIR/header.hdr
cp $IMG_DIR/zImage $IMG_DIR/DIR730.bin
cat $IMG_DIR/target.cramfs >> $IMG_DIR/DIR730.bin
cat $IMG_DIR/header.hdr >> $IMG_DIR/DIR730.bin
rm -rf $IMG_DIR/header.hdr

echo
echo "Firmware Image: $PWD/image/DIR730.bin"
echo
