#ifndef __PUBLIC_UTIL_H__
#define __PUBLIC_UTIL_H__

/* conver unsigned long to string */
#define  PUSH_IPADDR(ip)\
   (unsigned)(ip&0xff),\
   (unsigned)((ip>>8)&0xff),\
   (unsigned)((ip>>16)&0xff),\
   (unsigned)(ip>>24)


#define NULL_IP			"0.0.0.0"
#define NULL_MAC			"00:00:00:00:00:00"

#define CHANNEL1_FREQ	2412		// channel 1 frequency(MHZ)
#define CHANNEL14_FREQ  2484		// channel 14 frequency(MHZ)

#define SYS_INFO_MTD		"/dev/mtdblock1"
#define WLAN_DEF_BIN		"/etc/Wireless/RT2860AP/RT2860AP.bin"
#define SYS_BUF_SIZE		0x10000
#define SYS_INFO_INDEX	SYS_BUF_SIZE - sizeof(system_info) - 2
#define RF_WLAN_MAC		4
#define RF_LAN_MAC      40
#define RF_WAN_MAC      46
#define MAX_LOG_SIZE		20 /*KB*/

typedef struct {
	char hw_ver[4];
	char lan_mac[18];
	char wan_mac[18];
	char domain[5];
} system_info;

#ifdef CONFIG_SW5_POT
#define	MAX_POT_VALUE	540
#define BACKUP_POT_SIZE		0x30000					// must as same as CONFIG_LANG_PART_SIZE in kernel's config
#define BACKUP_POT_INDEX	BACKUP_POT_SIZE - MAX_POT_VALUE - 2
#define BACKUP_POT_MTD		"/dev/mtdblock3"		// as same as LANGUAGE_MTDBLK in project.h
typedef struct {
	unsigned char	POT_Value[MAX_POT_VALUE];
	unsigned int	POT_MaxValue;
	unsigned int	POT_Resolution;
	unsigned int	POT_RepackThreshold; 
} netgear_pot;
#endif	// CONFIG_SW5_POT

#define	IFACE_DB			"/etc/iface.db"		// records network interface information

#define MAIN_IFACE		0
#define BRIDGE_IFACE		1
#define LAN_IFACE			2
#define WAN_IFACE			3
#define WLAN_IFACE		4
#define WLAN_CLI_IFACE	5
#define PPP_IFACE			6
	
#ifdef CONFIG_RT3052_GUEST_ZONE
#define GUEST_IFACE		7
#endif	// CONFIG_RT3052_GUEST_ZONE
	
#define MAIN_IFACE_LEN				5
#define BRIDGE_IFACE_LEN			4
#define LAN_IFACE_LEN				7
#define WAN_IFACE_LEN				7
#define WLAN_IFACE_LEN				4
#define WLAN_CLI_IFACE_LEN			7
#define PPP_IFACE_LEN				5

#ifdef CONFIG_RT3052_GUEST_ZONE
#define GUEST_IFACE_LEN				4
#endif	// CONFIG_RT3052_GUEST_ZONE

#define WAN_DYNAMIC			0
#define WAN_STATIC			1
#define WAN_PPPOE				2
#define WAN_PPTP				3
#define WAN_L2TP				4
#define WAN_USB3G				5


#ifdef PACKET
#define MAX_WLAN_FILTER				64			// the Max number of Mac address for Wireless Filter
#define DEFAULT_LAN_IFACE			"eth2"
#define DEFAULT_WAN_IFACE			"eth2"
#else		// PACKET
#define DEFAULT_LAN_IFACE			"eth2.1"
#define DEFAULT_WAN_IFACE			"eth2.2"
#endif	// PACKET

#define DEFAULT_MAIN_IFACE			"eth2"
#define DEFAULT_BRIDGE_IFACE		"br0"
#define DEFAULT_WLAN_IFACE			"ra0"
#define DEFAULT_WLAN_CLI_IFACE	"apcli0"
#define DEFAULT_PPP_IFACE			"ppp0"
#define DEFAULT_CONN_MODE			"always_on"
#define DEFAULT_WIRELESS_DOMAIN	"0x06"		// Default Wireless Domain : USA(0x06)

#ifdef CONFIG_SW5_SUPPORT_ZEROCONFIG
#define DEFAULT_ZERO_CONFIG_IFACE_ALIAS	":0"
#endif	// CONFIG_SW5_SUPPORT_ZEROCONFIG

#ifdef CONFIG_SW5_DEVICE_MANAGERMENT_IP
#define DEFAULT_BRIDGE_IFACE_ALIAS		":1"
#endif	// CONFIG_SW5_DEVICE_MANAGERMENT_IP

#define DEFAULT_VERSION_PATH	"/www/chklst.txt"
#define DLINK_VERSION_PATH		"/www/version.txt"

#ifdef CONFIG_RT3052_GUEST_ZONE
#define DEFAULT_GUEST_IFACE		"ra1"
#endif	// CONFIG_RT3052_GUEST_ZONE

#define UDHCPD_PID				"/var/run/udhcpd.pid"	// must be as same as pidfile in /var/etc/udhcpd.conf
#define WPS_GPIO_PID				"/var/run/wps_gpio.pid"
#define MANAGER_PID				"/var/run/manager.pid"	// store system_manager's pid
#define DETECT_WLAN_PID			"/var/run/detect_wlan_pid"	// store detect_wlan_network's pid

#ifdef CONFIG_RT3052_WLAN_SCHEDULE
#define WLAN_SCHEDULE_PID		"/var/run/wlan_schedule_pid"	// store wlan_schedule's pid
#endif	//  CONFIG_RT3052_WLAN_SCHEDULE

#define DHCP_RESOLV_FILE		"/etc/resolv.conf"
#define PPP_RESOLV_FILE			"/var/etc/resolv.conf"
#define LEASES_FILE				"/var/misc/html.leases"
#define LOG_FILE     			"/var/log/messages"
#define LOG_DIE_FILE   			"/var/log/message_die_bak"
#define PING_RESULT				"/tmp/ping_result.log"
#define ROUTING_TABLE			"/tmp/routing_table"
#define STATISTIC_INFO			"/tmp/statistic"
#define CLIENT_MAC				"/tmp/client_mac"
#define WPS_STATUS				"/var/tmp/wps_status"
#define WSC_NOTIFIER				"/proc/wsc_notifier"
#define WLAN_CLI_NOTIFIER		"/proc/wlan_cli_notifier"
#define TMP_DEVICE_MODE			"/var/tmp/device_mode"
#define APCLI_STATUS				"/var/tmp/apcli0_status"
#define DHCPD_REVOKE_FILE		"/var/tmp/dhcp_revoke"
#define DHCPC_SERVER_FILE		"/var/tmp/dhcp_server.txt"
#define DHCPC_GATEWAY_FILE		"/var/tmp/dhcp_gateway.txt"	// must be as same as code line 1354 in apps/udhcp/dhcpc.c
#define DHCPC_LEASE_FILE		"/var/tmp/dhcpc.tmp"
#define WLAN_UP_TIME_FILE		"/var/tmp/wlan_up_time.txt"
#define LAN_UP_TIME_FILE		"/var/tmp/wan_connect_time.tmp"

#ifdef CONFIG_SW5_DNS_HIJACK
#define CONN_STATE				"/proc/conn_state"	// this varible is used in kernel/drivers/net/raeth/raether.c
#define DEVICE_MODE				"/proc/device_mode"
#endif // CONFIG_SW5_DNS_HIJACK

#ifdef CONFIG_SUPPORT_RT2860V2_2300
#ifdef CONFIG_RT3052_DETECT_WLAN_SECURITY_ERROR
#define WLAN_SECURITY_ERROR	"/proc/wlan_security_error"
#endif	// CONFIG_RT3052_DETECT_WLAN_SECURITY_ERROR
#endif	// CONFIG_SUPPORT_RT2860V2_2300

#ifdef IPv6_SUPPORT
#define DHCP_RESOLV_FILE_IPV6			"/var/etc/resolv_ipv6.conf"		// httpd/rc 
//#define DHCP_RESOLV_FILE_DUAL			"/var/etc/resolv_dual.conf"		// rc
#define CLIENT_MAC_IPV6				"/tmp/client_mac_ipv6"
#endif //IPv6_SUPPORT


#ifdef CONFIG_SW5_IGNORE_UDHCPC_SIGNAL
#define IGNORE_UDHCPC_FILE		"/var/tmp/ignore_udhcpc.txt"
#endif	// CONFIG_SW5_IGNORE_UDHCPC_SIGNAL

#ifdef CONFIG_SW5_SUPPORT_WLAN_STRENGTH_LED
#define WLAN_STRENGTH_NOTIFIER "/proc/wlan_strength_notifier"
#define WLAN_LED_READY			 "/proc/wlan_led_ready"
#endif	// CONFIG_SW5_SUPPORT_WLAN_STRENGTH_LED

#ifdef CONFIG_SW5_SUPPORT_DCC_HIJACK
#define PROC_ADMIN_PWD		 "/proc/admin_pwd"
#define PROC_DCC_AUTH		 "/proc/dcc_auth"

#ifdef CONFIG_SW5_SUPPORT_INTELLON
#define PROC_PLC_MAC		 "/proc/plc_mac"
#endif	// CONFIG_SW5_SUPPORT_INTELLON
#endif	// CONFIG_SW5_SUPPORT_DCC_HIJACK

#ifdef CONFIG_SW5_SUPPORT_INTELLON
#ifdef CONFIG_INTELLON_POWER_SAVING
#define PROC_PLC_POWER_SAVING		"/proc/plc_power_saving"
#define PLC_POWER_SAVING_PID		"/var/run/plc_power_saving"
#endif	// CONFIG_INTELLON_POWER_SAVING
#endif	// CONFIG_SW5_SUPPORT_INTELLON

/* for system_manager use */
#define DHCPC_DNS_SCRIPT			"/usr/share/udhcpc/default.bound-dns"
#define DHCPC_NODNS_SCRIPT			"/usr/share/udhcpc/default.bound-nodns"
#define DEFAULT_UDHCPD_CONF		"/etc/udhcpd.conf"
#define UDHCPD_CONF					"/var/etc/udhcpd.conf"
#define DEFAULT_UDHCPD_RELEASE	"/etc/udhcpd.leases"
#define UDHCPD_RELEASE				"/var/misc/udhcpd.leases"

#ifdef CONFIG_RT3052_SUPPORT_REATH_MODULE
#define RAETH_PATH				   "/lib/modules/2.6.21/kernel/drivers/net/raeth/raeth.ko"
#endif	// CONFIG_RT3052_SUPPORT_REATH_MODULE

#ifdef CONFIG_SUPPORT_RT2860V2_2300
#define WLAN_AP_PATH				   "/lib/modules/2.6.21/kernel/drivers/net/wireless/rt2860v2_ap_2300/rt2860v2_ap.ko"
#define WLAN_STA_PATH				"/lib/modules/2.6.21/kernel/drivers/net/wireless/rt2860v2_sta_2300/rt2860v2_sta.ko"
#else		// CONFIG_SUPPORT_RT2860V2_2300
#define WLAN_AP_PATH				   "/lib/modules/2.6.21/kernel/drivers/net/wireless/rt2860v2_ap/rt2860v2_ap.ko"
#define WLAN_STA_PATH				"/lib/modules/2.6.21/kernel/drivers/net/wireless/rt2860v2_sta/rt2860v2_sta.ko"
#endif	// CONFIG_SUPPORT_RT2860V2_2300

#define RT2860AP_DAT  				"/etc/Wireless/RT2860AP/RT2860AP.dat"
#define DEFAULT_AP_DAT  			"/mnt/Wireless/RT2860AP/RT2860AP.dat"
#define RT2860STA_DAT  				"/etc/Wireless/RT2860AP/RT2860STA.dat"
#define DEFAULT_STA_DAT  			"/mnt/Wireless/RT2860AP/RT2860STA.dat"
#define TIME_CONF				   	"/var/etc/ntp.conf"

#define USB_ADAPTER				0
#define SHARE_PORT				3
#define LM_KO						"/lib/modules/2.6.21/kernel/arch/mips/rt2880/lm.ko"
#define DWC_OTG_KO				"/lib/modules/2.6.21/kernel/drivers/usb/dwc_otg/dwc_otg.ko"

#ifdef CONFIG_SW5_SILEX_SHAREPORT
#define JCP_KO						"/home/jcp.ko"
#define SXUPTP_KO					"/home/sxuptp.ko"
#define JCP_CMD_KO				"/home/jcp_cmd.ko"
#define SXUPTP_GENERIC_KO		"/home/sxuptp_generic.ko"
#endif // CONFIG_SW5_SILEX_SHAREPORT

#ifdef CONFIG_SW5_KCODES_SHAREPORT
#define	KCODES_KO				"/lib/NetUSB_strip.ko"
#endif	// CONFIG_SW5_KCODES_SHAREPORT

#ifdef CONFIG_SW5_MULTI_LANG
#define MULTI_LANG_XML			"/www/xml/multi_lang.xml"
#endif	// CONFIG_SW5_MULTI_LANG

#ifdef CONFIG_SW5_LANG_PART
#define LANG_VER					"/www/xml/lang_ver.txt"
#define WWW_LANG_XML				"/www/xml/lang.xml"
#define WWW_MSG_XML				"/www/xml/msg.xml"
#define WWW_HELP_XML				"/www/xml/help.xml"
#define WWW_HINTS_XML			"/www/xml/hints.xml"
#define TMP_LANG_VER				"/tmp/lang_ver.txt"
#define TMP_LANG_XML				"/tmp/lang.xml"
#define TMP_MSG_XML				"/tmp/msg.xml"
#define TMP_HELP_XML				"/tmp/help.xml"
#define TMP_HINTS_XML			"/tmp/hints.xml"

#ifdef CONFIG_SW5_CLEAR_LANG_PACK
#define DEFAULT_XML_FOLDER		"/www/default_xml"
#define DEFAULT_LANG_XML		"/www/default_xml/lang.xml"
#define DEFAULT_MSG_XML			"/www/default_xml/msg.xml"
#define DEFAULT_HELP_XML		"/www/default_xml/help.xml"
#define DEFAULT_HINTS_XML		"/www/default_xml/hints.xml"
#define CLEAR_LANG_INFO			"/var/tmp/clear_lang.txt"
#endif	// CONFIG_SW5_CLEAR_LANG_PACK

#endif	// CONFIG_SW5_LANG_PART

#ifdef CONFIG_WEB_404_REDIRECT
#define LIGHTTPD_404_INFO		"/var/tmp/lighttpd_404_info.txt"
#endif	//CONFIG_WEB_404_REDIRECT

#if defined(CONFIG_SW5_LIGHTTPD_BASIC_AUTH) || defined(CONFIG_SW5_LIGHTTPD_GET_PWD)
#define LIGHTTPD_USER_CONF		"/etc/lighttpd/lighttpd.user"
#endif //defined(CONFIG_SW5_LIGHTTPD_BASIC_AUTH) || defined(CONFIG_SW5_LIGHTTPD_GET_PWD)

#define IP_UP_CMD					"/var/sbin/ip-up"
#define IP_DOWN_CMD				"/var/sbin/ip-down"

#define	DEFAULT_DOMAIN_INDEX			5	// NA
typedef struct {
	int  number;	
	char country[25];
	char country_code[3];			// country abbreviate(ISO3166)
	char version_abbr[6];			// for D-Link version.txt
	char chklst_abbr[8];			// for chklst.txt
	char country_region;			// 0: channels 1-11, 1: channels 1-13, 2: channels 10-11, 3: channels 10-13, 4: channel 14, 5: channels 1-14, 6: channels 3-9, 7: channels 5-13	
	char channel_num;			// number of channel
} wlan_domain;

/* definitions below are defined in mipsel-linux-2.6.21/drivers/net/wireless/rt2860v2/include/oid.h  */
#if WIRELESS_EXT <= 11
#ifndef SIOCDEVPRIVATE
#define SIOCDEVPRIVATE 0x8BE0
#endif
#define SIOCIWFIRSTPRIV SIOCDEVPRIVATE
#endif

#define RTPRIV_IOCTL_WSC_PROFILE		(SIOCIWFIRSTPRIV + 0x12)	// for get AP's wsc profile
#define RT_OID_WSC_PIN_CODE			0x0752				// for get ra0 wps pin
#define RT_OID_APCLI_WSC_PIN_CODE	0x074A 				// for get apcli0 wps pin

/* definitions below for site survey use */
#define WPA_OUI_TYPE		0x01F25000
#define WPA_OUI			0x00F25000
#define WPA2_OUI			0x00AC0F00
#define CISCO_OUI			0x00964000 

typedef struct _PAIR_CHANNEL_FREQ_ENTRY
{
	unsigned long	lChannel;
	unsigned long	lFreq;
} PAIR_CHANNEL_FREQ_ENTRY, *PPAIR_CHANNEL_FREQ_ENTRY;

#define RTPRIV_IOCTL_GSITESURVEY		(SIOCIWFIRSTPRIV + 0x0D)
#define	MAX_NUMBER_OF_SITE			63

#ifdef CONFIG_SUPPORT_RT2860V2_2300

typedef struct _RT_802_11_SITE_INFO {
	unsigned long	channel;  
	unsigned int	ssid_len;
	char 		ssid[33];
	char 		bssid[20];
	char 		wep_status[8];
	char 		auth_mode[15];
	int 		signal;
	char 		wireless_mode[8];
	char		ext_channel[8];
	char 		network_type[3];	// Ad: ad-hoc, In: AP
} RT_802_11_SITE_INFO, *pRT_802_11_SITE_INFO;

#else	// CONFIG_SUPPORT_RT2860V2_2300	

typedef struct _RT_802_11_SITE_INFO {
	unsigned long	channel;  
	char 		ssid[33];
	char 		bssid[20];
	char 		wep_status[8];
	char 		auth_mode[15];
	int 		signal;
	char 		wireless_mode[8];
	char 		network_type[3];	// Ad: ad-hoc, In: AP
} RT_802_11_SITE_INFO, *pRT_802_11_SITE_INFO;

#endif	// CONFIG_SUPPORT_RT2860V2_2300	

typedef struct _RT_802_11_SITE_SURVEY_TABLE {
    unsigned long	Num;
    RT_802_11_SITE_INFO Entry[MAX_NUMBER_OF_SITE];
} RT_802_11_SITE_SURVEY_TABLE, *PRT_802_11_SITE_SURVEY_TABLE;
/********************************************************/

/* definitions below for get wireless client use */
#define RTPRIV_IOCTL_GET_MAC_TABLE 	(SIOCIWFIRSTPRIV + 0x0F)
#define MAC_ADDR_LEN 					6
#define ETH_LENGTH_OF_ADDRESS 		6
#define MAX_LEN_OF_MAC_TABLE 			32

typedef union _MACHTTRANSMIT_SETTING 
{
	struct 
	{
		unsigned short MCS:7; // MCS
		unsigned short BW:1; //channel bandwidth 20MHz or 40 MHz
		unsigned short ShortGI:1;
		unsigned short STBC:2; //SPACE
		unsigned short rsv:3;
		unsigned short MODE:2; // Use definition MODE_xxx.
	
	}field;
	unsigned short word;
} MACHTTRANSMIT_SETTING;

typedef struct _RT_802_11_MAC_ENTRY {
   unsigned char	Addr[MAC_ADDR_LEN];
   unsigned char  Aid;
   unsigned char  Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
   unsigned char  MimoPs;  // 0:MMPS_STATIC, 1:MMPS_DYNAMIC, 3:MMPS_Enabled
   char	AvgRssi0;
	char	AvgRssi1;
	char	AvgRssi2;
	unsigned int	ConnectedTime;
   MACHTTRANSMIT_SETTING	TxRate;
} RT_802_11_MAC_ENTRY;

typedef struct _RT_802_11_MAC_TABLE {
    unsigned long       Num;
    RT_802_11_MAC_ENTRY Entry[MAX_LEN_OF_MAC_TABLE];
} RT_802_11_MAC_TABLE;
/********************************************************/

/* definitions below for AP Client(get_apc_profile) use */
#ifdef CONFIG_SUPPORT_RT2860V2_2300
#define RTPRIV_IOCTL_APCLI_WSC_PROFILE	(SIOCIWFIRSTPRIV + 0x1C)
#else	// CONFIG_SUPPORT_RT2860V2_2300
#define RTPRIV_IOCTL_APCLI_WSC_PROFILE	(SIOCIWFIRSTPRIV + 0x17)
#endif	// CONFIG_SUPPORT_RT2860V2_2300

#define NDIS_802_11_LENGTH_SSID         32
typedef struct _NDIS_802_11_SSID
{
    unsigned int   SsidLength;         // length of SSID field below, in bytes;
                                			// this can be zero.
    unsigned char  Ssid[NDIS_802_11_LENGTH_SSID];           // SSID information field
} NDIS_802_11_SSID, *PNDIS_802_11_SSID;

// WSC configured credential
typedef	struct	_WSC_CREDENTIAL
{
	NDIS_802_11_SSID	SSID;				// mandatory
	unsigned short		AuthType;			// mandatory, 1: open, 2: wpa-psk, 4: shared, 8:wpa, 0x10: wpa2, 0x20: wpa2-psk
	unsigned short		EncrType;			// mandatory, 1: none, 2: wep, 4: tkip, 8: aes
	unsigned char		Key[64];			// mandatory, Maximum 64 byte
	unsigned short	   KeyLength;
	unsigned char		MacAddr[6];			// mandatory, AP MAC address
	unsigned char		KeyIndex;			// optional, default is 1
	unsigned char		Rsvd[3];			// Make alignment
}	WSC_CREDENTIAL, *PWSC_CREDENTIAL;

// WSC configured profiles
typedef	struct	_WSC_PROFILE
{
	unsigned int	ProfileCnt;
	unsigned int	ApplyProfileIdx;
	WSC_CREDENTIAL	Profile[8];				// Support up to 8 profiles
}	WSC_PROFILE, *PWSC_PROFILE;
/********************************************************/

/* definitions below to get current ssid and bssid for Station */
#define RT_PRIV_IOCTL (SIOCIWFIRSTPRIV + 0x01)
#define OID_802_11_SSID 	0x0509
#define OID_802_11_BSSID 	0x050A

/* definitions below to get wsc profile for Station */
#define RTPRIV_IOCTL_GET_WSC_PROFILE (SIOCIWFIRSTPRIV + 0x1B)

/* definitions below to get Tx/Rx data rate for Station */
#define	RT_OID_802_11_QUERY_LAST_RX_RATE		0x0613
#define	RT_OID_802_11_QUERY_LAST_TX_RATE		0x0632

/* definitions below to get devices which are doing WPS PIN now */
#ifdef CONFIG_SUPPORT_RT2860V2_2300
#ifdef CONFIG_RT3052_EMPTY_SSID_FOR_STA_PIN

#define RTPRIV_IOCTL_SET_WSC_PROFILE_U32_ITEM 		(SIOCIWFIRSTPRIV + 0x14)
#define RTPRIV_IOCTL_SET_WSC_PROFILE_STRING_ITEM   (SIOCIWFIRSTPRIV + 0x16)
#define WSC_ID_DEVICE_PWD_ID  0x1012
#define WSC_ID_SEL_REGISTRAR  0x1041
#define STATUS_WSC_EAP_FAIL_SENT                30      // Sending EAP-Fail
#define STATUS_WSC_ERROR_HASH_FAIL              31      // WSC_ERROR_HASH_FAIL
#define STATUS_WSC_ERROR_HMAC_FAIL              32      // WSC_ERROR_HMAC_FAIL
#define STATUS_WSC_ERROR_DEV_PWD_AUTH_FAIL      33      // WSC_ERROR_DEV_PWD_AUTH_FAIL
#define STATUS_WSC_CONFIGURED	34

// Value of WSC_IE_DEV_PASS_ID 0x1012
#define	DEV_PASS_ID_PIN						0x0000
#define	DEV_PASS_ID_PBC						0x0004
#endif	// CONFIG_RT3052_EMPTY_SSID_FOR_STA_PIN

#define OID_GET_SET_TOGGLE						0x8000
#define OID_802_11_BSSID_LIST_SCAN			(0x0508 | OID_GET_SET_TOGGLE)
#define OID_802_11_BSSID_LIST					0x0609
#define RT_OID_WE_VERSION_COMPILED        0x0622
#define RT_OID_WSC_QUERY_STATUS				0x0751
#define NDIS_802_11_LENGTH_RATES        	8
#define NDIS_802_11_LENGTH_RATES_EX     	16
typedef unsigned char NDIS_802_11_RATES[NDIS_802_11_LENGTH_RATES];        // Set of 8 data rates
typedef unsigned char NDIS_802_11_RATES_EX[NDIS_802_11_LENGTH_RATES_EX];  // Set of 16 data rates
typedef signed long NDIS_802_11_RSSI;           // in dBm

enum {    
	WSC_CREDENTIAL_COUNT = 1,
	WSC_CREDENTIAL_SSID = 2,
	WSC_CREDENTIAL_AUTH_MODE = 3,
	WSC_CREDENTIAL_ENCR_TYPE = 4,
	WSC_CREDENTIAL_KEY_INDEX = 5,
	WSC_CREDENTIAL_KEY = 6,
	WSC_CREDENTIAL_MAC = 7,	
	WSC_SET_DRIVER_CONNECT_BY_CREDENTIAL_IDX = 8,
	WSC_SET_DRIVER_AUTO_CONNECT = 9,
	WSC_SET_CONF_MODE = 10, // Enrollee or Registrar
	WSC_SET_MODE = 11,      // PIN or PBC
	WSC_SET_PIN = 12,
	WSC_SET_SSID = 13,
	WSC_START = 14,
	WSC_STOP = 15,
	WSC_GEN_PIN_CODE = 16,
	WSC_AP_BAND = 17,
	WSC_SET_BSSID = 18,
};

// Added new types for OFDM 5G and 2.4G
typedef enum _NDIS_802_11_NETWORK_TYPE
{
   Ndis802_11FH, 
   Ndis802_11DS, 
   Ndis802_11OFDM5,    
   Ndis802_11OFDM24,
	Ndis802_11Automode,
   Ndis802_11OFDM5_N,
   Ndis802_11OFDM24_N,
   Ndis802_11NetworkTypeMax    // not a real type, defined as an upper bound
} NDIS_802_11_NETWORK_TYPE, *PNDIS_802_11_NETWORK_TYPE;

typedef enum _NDIS_802_11_NETWORK_INFRASTRUCTURE
{
   Ndis802_11IBSS,
   Ndis802_11Infrastructure,
   Ndis802_11AutoUnknown,
   Ndis802_11Monitor,
   Ndis802_11InfrastructureMax     // Not a real value, defined as upper bound
} NDIS_802_11_NETWORK_INFRASTRUCTURE, *PNDIS_802_11_NETWORK_INFRASTRUCTURE;

typedef	struct _WSC_IE
{
	unsigned short	Type;
	unsigned short	Length;
	unsigned char	Data[1];	// variable length data
}	WSC_IE, *PWSC_IE;

typedef struct {
    unsigned char	Eid;
    unsigned char Len;
    unsigned char Octet[1];
} EID_STRUCT,*PEID_STRUCT, BEACON_EID_STRUCT, *PBEACON_EID_STRUCT;

typedef struct _WPS_AP_TABLE
{
	unsigned char 		 MacAddr[6];
	NDIS_802_11_RSSI	 rssi;
	int					 channel;
} WPS_AP_TABLE;

typedef struct _NDIS_802_11_CONFIGURATION_FH
{
   unsigned long           Length;            // Length of structure
   unsigned long           HopPattern;        // As defined by 802.11, MSB set 
   unsigned long           HopSet;            // to one if non-802.11
   unsigned long           DwellTime;         // units are Kusec
} NDIS_802_11_CONFIGURATION_FH, *PNDIS_802_11_CONFIGURATION_FH;

typedef struct _NDIS_802_11_CONFIGURATION
{
   unsigned long           Length;             // Length of structure
   unsigned long           BeaconPeriod;       // units are Kusec
   unsigned long           ATIMWindow;         // units are Kusec
   unsigned long           DSConfig;           // Frequency, units are kHz
   NDIS_802_11_CONFIGURATION_FH    FHConfig;
} NDIS_802_11_CONFIGURATION, *PNDIS_802_11_CONFIGURATION;

typedef struct _NDIS_WLAN_BSSID
{
    unsigned long                       Length;             // Length of this structure
    unsigned char             			 MacAddress[6];         // BSSID
    unsigned char                       Reserved[2];
    NDIS_802_11_SSID                    Ssid;               // SSID
    unsigned int                        Privacy;            // WEP encryption requirement
    long                    				 Rssi;               // receive signal strength in dBm
    NDIS_802_11_NETWORK_TYPE            NetworkTypeInUse;
    NDIS_802_11_CONFIGURATION           Configuration;
    NDIS_802_11_NETWORK_INFRASTRUCTURE  InfrastructureMode;
    NDIS_802_11_RATES                	 SupportedRates;	
} NDIS_WLAN_BSSID, *PNDIS_WLAN_BSSID;

typedef struct _NDIS_802_11_FIXED_IEs 
{
    unsigned char 	Timestamp[8];
    unsigned short 	BeaconInterval;
    unsigned short 	Capabilities;
} NDIS_802_11_FIXED_IEs, *PNDIS_802_11_FIXED_IEs;

typedef struct _NDIS_802_11_VARIABLE_IEs 
{
    unsigned char ElementID;
    unsigned char Length;    // Number of bytes in data field
    unsigned char data[1];
} NDIS_802_11_VARIABLE_IEs, *PNDIS_802_11_VARIABLE_IEs;

// Added Capabilities, IELength and IEs for each BSSID
typedef struct _NDIS_WLAN_BSSID_EX
{
    unsigned long                       Length;             // Length of this structure
    unsigned char             			 MacAddress[6];         // BSSID
    unsigned char                       Reserved[2];
    NDIS_802_11_SSID                    Ssid;               // SSID
    unsigned int                        Privacy;            // WEP encryption requirement
    long                    				 Rssi;               // receive signal
                                                            // strength in dBm
    NDIS_802_11_NETWORK_TYPE            NetworkTypeInUse;
    NDIS_802_11_CONFIGURATION           Configuration;
    NDIS_802_11_NETWORK_INFRASTRUCTURE  InfrastructureMode;
    NDIS_802_11_RATES_EX                SupportedRates;
	
    unsigned long                       IELength;
    unsigned char                       IEs[1];
} NDIS_WLAN_BSSID_EX, *PNDIS_WLAN_BSSID_EX;

typedef struct _NDIS_802_11_BSSID_LIST_EX
{
    unsigned int            NumberOfItems;      // in list below, at least 1
    NDIS_WLAN_BSSID_EX      Bssid[1];
} NDIS_802_11_BSSID_LIST_EX, *PNDIS_802_11_BSSID_LIST_EX;
#endif	// CONFIG_SUPPORT_RT2860V2_2300

// MIMO Tx parameter, ShortGI, MCS, STBC, etc.  these are fields in TXWI. Don't change this definition!!!
typedef union  _HTTRANSMIT_SETTING {
#ifdef RT_BIG_ENDIAN
	struct	{
	unsigned short		MODE:2;	// Use definition MODE_xxx.  
//	unsigned short		rsv:3;	 
	unsigned short		TxBF:1;
	unsigned short		rsv:2;
	unsigned short		STBC:2;	//SPACE 
	unsigned short		ShortGI:1;
	unsigned short		BW:1;	//channel bandwidth 20MHz or 40 MHz
	unsigned short   	MCS:7;                 // MCS
	}	field;
#else
	struct	{
	unsigned short   	MCS:7;                 // MCS
	unsigned short		BW:1;	//channel bandwidth 20MHz or 40 MHz
	unsigned short		ShortGI:1;
	unsigned short		STBC:2;	//SPACE 
//	unsigned short		rsv:3;
	unsigned short		rsv:2;
	unsigned short		TxBF:1;
	unsigned short		MODE:2;	// Use definition MODE_xxx.  
	}	field;
#endif
	unsigned short		word;
 } HTTRANSMIT_SETTING, *PHTTRANSMIT_SETTING;
 
 /* definitions below to get extension channel for Station */
 #define	RT_OID_802_11_QUERY_HT_PHYMODE		0x0633
 
 typedef enum _RT_802_11_PHY_MODE {
	PHY_11BG_MIXED = 0,
	PHY_11B,
	PHY_11A,
	PHY_11ABG_MIXED,
	PHY_11G,
//#ifdef DOT11_N_SUPPORT
	PHY_11ABGN_MIXED,	// both band   5
	PHY_11N_2_4G,		// 11n-only with 2.4G band   	6
	PHY_11GN_MIXED,	// 2.4G band      7
	PHY_11AN_MIXED,	// 5G  band       8
	PHY_11BGN_MIXED,	// if check 802.11b.      9
	PHY_11AGN_MIXED,	// if check 802.11b.      10
	PHY_11N_5G,			// 11n-only with 5G band		11
//#endif // DOT11_N_SUPPORT //
} RT_802_11_PHY_MODE;

 // This is OID setting structure. So only GF or MM as Mode. This is valid when our wirelss mode has 802.11n in use.
typedef struct {
	RT_802_11_PHY_MODE		PhyMode; 	// 
	unsigned char				TransmitNo;
	unsigned char				HtMode; 	//HTMODE_GF or HTMODE_MM
	unsigned char				ExtOffset;	//extension channel above or below
	unsigned char				MCS;
	unsigned char   			BW;
	unsigned char				STBC;
	unsigned char				SHORTGI;
	unsigned char				rsv;
} OID_SET_HT_PHYMODE, *POID_SET_HT_PHYMODE;


/*******************************************************/
// below is used for internet_sessions and 
// it is based on /proc/net/ip_conntrack
/* active session file */
#define IP_CONNTRACK_FILE		"/proc/net/ip_conntrack"
#define MAX_NUMBER_FIELD		18

typedef struct napt_session_info_s{
	char protocol[8];
	char local_ip[16];
	char remote_ip[16];
	char local_port[8];
	char remote_port[8];
	char public_port[8];
	char timeout[8];
	char state[8];
	char direction[8];
	struct napt_session_info_s *next;
}napt_session_info_t;

typedef struct napt_session_table_s{
	char local_ip[16];
	int tcp_count;
	int udp_count;
	napt_session_info_t *next;
	napt_session_info_t *last;
}napt_session_table_t;

typedef struct
{
	int num_list;
	napt_session_table_t *p_st_napt_list;
}T_NAPT_LIST_INFO;


/********************************************************/


#define SYS_IDLE							0
#define SYS_BUSY							1
#define REBOOT_SIGNAL					50
#define HW_DEFAULT_SIGNAL				51		// a signal for pressing the reset button over 5 seconds
#define SW_DEFAULT_SIGNAL				52		// a signal for clicking the restore to default button on GUI
#define HW_PBC_SIGNAL					53		// a signal for pressing the WPS PBC button
#define SW_PBC_SIGNAL					54		// a signal for clicking the PBC button on GUI
#define SWITCH_DOWN_SIGNAL				55
#define SWITCH_UP_SIGNAL				56
#define CABLE_DOWN_SIGNAL				57		// a signal for cable un-plug
#define CABLE_UP_SIGNAL					58		// s signal for cable plugs in
#define LAN_SIGNAL						59
#define WAN_SIGNAL						60
#define WLAN_SIGNAL						61
#define PIN_SIGNAL						62		// a signal for WPS PIN
#define UPDATE_WPS_SIGNAL				63		// a signal for updating WPS status and wireless information
#define WLAN_FILTER_SIGNAL				64
#define FILTER_SIGNAL					65		// for convert nvram use and send reset filter signal to rc
#define APPLICATION_SIGNAL				66		// for convert nvram use and send reset application signal to rc
#define RESET_ALL_SIGNAL				67
#define WLAN_CLI_UDHCPC_SIGNAL		68
#define TIME_SIGNAL						69
#define SYSLOG_SIGNAL					70
#define CLEAR_LOG_SIGNAL				71
#define SET_STATIC_DHCP_SIGNAL		72
#define RESET_WSC_SSID_SIGNAL			73
#define INIT_WLAN_LED_SIGNAL			74
#define STOP_WPS_SIGNAL					75
#define TELNETD_SIGNAL					76
#define ATED_SIGNAL						77

#ifdef CONFIG_3G_USB_TOOLS
#define CARD_INFO_SIGNAL				78
#define APN_SIGNAL						79
#endif	// CONFIG_3G_USB_TOOLS

#define QOS_SIGANL              		80

#ifdef CONFIG_RT3052_WLAN_SCHEDULE
#define UPDATE_FROM_WLAN_SIGNAL		81
#define UPDATE_FROM_SCH_SIGNAL		82
#define WLAN_ON_SIGNAL					83
#define WLAN_OFF_SIGNAL					84

#ifdef CONFIG_RT3052_GUEST_ZONE
#define GUEST_ON_SIGNAL					85
#define GUEST_OFF_SIGNAL				86
#endif	// CONFIG_RT3052_GUEST_ZONE

#endif	// CONFIG_RT3052_WLAN_SCHEDULE

#ifdef CONFIG_RT3052_SUPPORT_CLONE_CLIENT_MAC
#define CLONE_CLIENT_MAC_SIGNAL		87
#endif	// CONFIG_RT3052_SUPPORT_CLONE_CLIENT_MAC

#if defined(CONFIG_SW5_LIGHTTPD_BASIC_AUTH) || defined(CONFIG_SW5_LIGHTTPD_GET_PWD)
#define LIGHTTPD_USER_SIGNAL			88
#define LIGHTTPD_PID						"/var/run/lighttpd.pid"
#endif // defined(CONFIG_SW5_LIGHTTPD_BASIC_AUTH) || defined(CONFIG_SW5_LIGHTTPD_GET_PWD)

#ifdef CONFIG_SW5_NETGEAR_AUTO_UPGRADE
#define CREATE_XML_FROM_DB_SIGNAL						89
#define NGR_UPGRADE_GET_FILE_INFO_SIGNAL				90
#define NGR_UPGRADE_GET_LANGUAGE_SIGNAL				91
#define NGR_UPGRADE_GET_FW_FILE_SIGNAL					92

#endif	// CONFIG_SW5_NETGEAR_AUTO_UPGRADE

#ifdef CONFIG_SW5_DNS_HIJACK
#define BLANK_STATE_SIGANL				93
#define DISABLE_BLANK_STATE_SIGANL  94
#endif	// CONFIG_SW5_DNS_HIJACK

#ifdef UDHCPD_REVOKE
#define REVOKE_DHCP_SIGNAL				95
#endif	// UDHCPD_REVOKE

#ifdef CONFIG_SW5_SUPPORT_FW_UPGRADE_LED
#define UPLOAD_FW_SIGNAL	96
#define WRITE_FW_SIGNAL		97
#define RESTORE_FW_SIGNAL	98
#endif	// CONFIG_SW5_SUPPORT_FW_UPGRADE_LED

#ifdef CONFIG_SW5_SUPPORT_RESET_BTN_LED
#define REBOOT_LED_SIGNAL	99
#define RESTORE_LED_SIGNAL	100
#endif	// CONFIG_SW5_SUPPORT_RESET_BTN_LED

#ifdef CONFIG_SW5_SUPPORT_NGR_WPS_LED
#define WPS_LED1_SIGNAL		101
#define WPS_LED2_SIGNAL		102
#define WPS_SUCCESS_SIGNAL	103
#define WPS_FAIL_SIGNAL		104
#define WPS_OFF_SIGNAL		105
#endif	// CONFIG_SW5_SUPPORT_NGR_WPS_LED

#ifdef CONFIG_SW5_SUPPORT_WLAN_STRENGTH_LED
#define WLAN_STR_SIGNAL				106
#define WLAN_OK_SIGNAL				107
#define WLAN_WEAK_SIGNAL			108
#define WLAN_DISCONNECT_SIGNAL	109
#endif	// CONFIG_SW5_SUPPORT_WLAN_STRENGTH_LED

#ifdef CONFIG_SW5_NETGEAR_AUTO_UPGRADE
#define NGR_UPGRADE_STOP_SIGNAL 110
#endif	// CONFIG_SW5_NETGEAR_AUTO_UPGRADE

#ifdef CONFIG_SW5_STATION_ONLY
#define ENABLE_STA_AUTO_CONN_SIGNAL 111
#define DISABLE_STA_AUTO_CONN_SIGNAL 112
#endif	// CONFIG_SW5_STATION_ONLY

#ifdef CONFIG_SW5_SUPPORT_INTELLON
#define UPDATE_PLC_NETWORK_NAME_SIGNAL 113
#define UPDATE_PLC_QOS_SETTINGS_SIGNAL 114
#endif	// CONFIG_SW5_SUPPORT_INTELLON

#ifdef CONFIG_SW5_NETGEAR_AUTO_UPGRADE
#define CHANGE_DEFAULT_XML_BY_BROWSER_SIGNAL 115
#endif	// CONFIG_SW5_NETGEAR_AUTO_UPGRADE

#define UPDATE_WLAN_CONFIG_SIGNAL 116
#define SET_DYNAMIC_DHCP_SIGNAL 117

#ifdef IPv6_SUPPORT
#define RESET_IPV6_LLA_SIGNAL 118
#endif	//IPv6_SUPPORT

#ifdef CONFIG_SW5_SUPPORT_ZEROCONFIG
#define	ZEROCONFIG_SIGNAL	119
#endif	// CONFIG_SW5_SUPPORT_ZEROCONFIG

#if defined(CONFIG_NETGEAR) && defined(CONFIG_SW5_POWER_DUAL_COLOR_LED)
#define SYSTEM_READY_SIGNAL 120		// to turn on the Power LED in Green color
#endif	// defined(CONFIG_NETGEAR) && defined(CONFIG_SW5_POWER_DUAL_COLOR_LED)

extern int get_pid(const char *file);
extern int get_wlan_domain(char *which_domain);
extern int get_coexist_ap(void);
extern int get_nat_enable(void);
extern int get_client_mode(void);
extern int get_station_status(void);
extern int ping_connected_device(int device_mode);
extern int get_port_connect_state(int port_num);
extern void send_manager_signal(int sig);
extern void get_system_info(system_info *sys_info);
extern void get_network_info(char *iface, int ioctl_cmd, char *info);
extern void get_network_iface(char *iface, int which_iface);
extern void set_dhcpc_gateway(char *gateway);
extern T_NAPT_LIST_INFO* get_napt_session(int proto_flag, char *packet_type);

#ifdef CONFIG_TC
extern void measure_uplink_bandwidth(char *bandwidth);
#endif

#ifdef CONFIG_SW5_MULTI_LANG
void write_multi_lang_xml(char *db_file);
#endif	// CONFIG_SW5_MULTI_LANG

void parse_mac_address_to_numberic(unsigned char *, unsigned char *);


napt_session_table_t session_list[0];
T_NAPT_LIST_INFO napt_session_list;

/* NetGear Language Country List */
#ifdef CONFIG_SW5_NETGEAR_AUTO_UPGRADE
typedef struct {
	char country_code[5];	// Base NetGear Spec
	char country_name[20];
} ngr_language;
#endif	// CONFIG_SW5_NETGEAR_AUTO_UPGRADE

#endif // end of __PUBLIC_UTIL_H__
